xine-lib: xine-lib-1.2.12/src/post/mosaico/mosaico.c File Reference

xine-lib 1.2.12

Data Structures | Macros | Typedefs | Functions | Variables
mosaico.c File Reference
`#include <pthread.h>`
`#include <xine/xine_internal.h>`
`#include <xine/post.h>`

## Data Structures
struct | mosaico_parameters_s
struct | post_mosaico_s

## Macros
#define | LOG_MODULE "mosaico"
#define | LOG_VERBOSE

## Typedefs
typedef struct mosaico_parameters_s | mosaico_parameters_t

## Functions
| PARAM_ITEM (PARAM_ITEM(POST_PARAM_TYPE_INT, pip_num, PARAM_ITEM(NULL, 1, PARAM_ITEM(INT_MAX, 1, "which picture slots settings are being edited")
static xine_post_api_descr_t * | mosaico_get_param_descr (void)
static int | mosaico_set_parameters (xine_post_t *this_gen, const void *param_gen)
static int | mosaico_get_parameters (xine_post_t *this_gen, void *param_gen)
static char * | mosaico_get_help (void)
static void | mosaico_close (xine_video_port_t *port_gen, xine_stream_t *stream)
static int | mosaico_intercept_frame (post_video_port_t *port, vo_frame_t *frame)
static void | frame_copy_content (vo_frame_t *to, vo_frame_t *from)
static void | frame_paste (post_mosaico_t *this, vo_frame_t *background, int pip_num)
static int | mosaico_draw_background (vo_frame_t *frame, xine_stream_t *stream)
static int | mosaico_draw (vo_frame_t *frame, xine_stream_t *stream)
static void | mosaico_dispose (post_plugin_t *this_gen)
static post_plugin_t * | mosaico_open_plugin (post_class_t *class_gen, int inputs, xine_audio_port_t **audio_target, xine_video_port_t **video_target)
static void * | mosaico_init_plugin (xine_t *xine, const void *data)

## Variables
static const post_info_t | mosaico_special_info
const plugin_info_t xine_plugin_info[] | EXPORTED

## Macro Definition Documentation

## ◆ LOG_MODULE

#define LOG_MODULE "mosaico"

## ◆ LOG_VERBOSE

#define LOG_VERBOSE

## Typedef Documentation

## ◆ mosaico_parameters_t

typedef struct mosaico_parameters_s mosaico_parameters_t

## Function Documentation

## ◆ frame_copy_content()

static void frame_copy_content | ( | vo_frame_t * | to,
|  | vo_frame_t * | from
| ) |  |
| static

References vo_frame_s::base, vo_frame_s::format, vo_frame_s::height, vo_frame_s::pitches, xine_fast_memcpy, XINE_IMGFMT_YUY2, and XINE_IMGFMT_YV12.

Referenced by mosaico_draw_background().

## ◆ frame_paste()

static void frame_paste | ( | post_mosaico_t * | this,
|  | vo_frame_t * | background,
|  | int | pip_num
| ) |  |
| static

References vo_frame_s::base, vo_frame_s::width, XINE_IMGFMT_YUY2, and XINE_IMGFMT_YV12.

Referenced by mosaico_draw_background().

## ◆ mosaico_close()

static void mosaico_close | ( | xine_video_port_t * | port_gen,
|  | xine_stream_t * | stream
| ) |  |
| static

References _x_post_dec_usage, xine_video_port_s::close, NULL, post_video_port_s::original_port, post_video_port_s::post, and post_video_port_s::stream.

Referenced by mosaico_open_plugin().

## ◆ mosaico_dispose()

static void mosaico_dispose | ( | post_plugin_t * | this_gen | ) |
| static

References _x_post_dispose().

Referenced by mosaico_open_plugin().

## ◆ mosaico_draw()

static int mosaico_draw | ( | vo_frame_t * | frame,
|  | xine_stream_t * | stream
| ) |  |
| static

References _x_assert, _x_post_frame_u_turn(), vo_frame_s::free, vo_frame_s::lock, vo_frame_s::port, post_video_port_s::post, post_video_port_s::stream, and vo_frame_s::vpts.

Referenced by mosaico_open_plugin().

## ◆ mosaico_draw_background()

static int mosaico_draw_background | ( | vo_frame_t * | frame,
|  | xine_stream_t * | stream
| ) |  |
| static

References _x_post_frame_copy_down(), _x_post_frame_copy_up(), vo_frame_s::bad_frame, vo_frame_s::draw, vo_frame_s::duration, vo_frame_s::flags, vo_frame_s::format, frame_copy_content(), frame_paste(), vo_frame_s::free, xine_video_port_s::get_frame, vo_frame_s::height, vo_frame_s::next, post_video_port_s::original_port, vo_frame_s::port, post_video_port_s::post, vo_frame_s::ratio, VO_BOTH_FIELDS, vo_frame_s::vpts, and vo_frame_s::width.

Referenced by mosaico_open_plugin().

## ◆ mosaico_get_help()

static char * mosaico_get_help | ( | void |  | ) |
| static

References _.

Referenced by mosaico_open_plugin().

## ◆ mosaico_get_param_descr()

static xine_post_api_descr_t * mosaico_get_param_descr | ( | void |  | ) |
| static

Referenced by mosaico_open_plugin().

## ◆ mosaico_get_parameters()

static int mosaico_get_parameters | ( | xine_post_t * | this_gen,
|  | void * | param_gen
| ) |  |
| static

References mosaico_parameters_s::h, mosaico_parameters_s::pip_num, mosaico_parameters_s::w, mosaico_parameters_s::x, and mosaico_parameters_s::y.

Referenced by mosaico_open_plugin().

## ◆ mosaico_init_plugin()

static void * mosaico_init_plugin | ( | xine_t * | xine,
|  | const void * | data
| ) |  |
| static

References mosaico_open_plugin(), N_, NULL, and post_class_s::open_plugin.

## ◆ mosaico_intercept_frame()

static int mosaico_intercept_frame | ( | post_video_port_t * | port,
|  | vo_frame_t * | frame
| ) |  |
| static

References vo_frame_s::format, and XINE_IMGFMT_YV12.

Referenced by mosaico_open_plugin().

## ◆ mosaico_open_plugin()

static post_plugin_t * mosaico_open_plugin | ( | post_class_t * | class_gen,
|  | int | inputs,
|  | xine_audio_port_t ** | audio_target,
|  | xine_video_port_t ** | video_target
| ) |  |
| static

References _x_asprintf(), _x_post_init(), _x_post_intercept_video_port(), xine_video_port_s::close, vo_frame_s::draw, post_video_port_s::frame_lock, input(), post_video_port_s::intercept_frame, lprintf, mosaico_close(), mosaico_dispose(), mosaico_draw(), mosaico_draw_background(), mosaico_get_help(), mosaico_get_param_descr(), mosaico_get_parameters(), mosaico_intercept_frame(), mosaico_set_parameters(), xine_post_in_s::name, post_video_port_s::new_frame, post_video_port_s::new_port, NULL, post_video_port_s::port_lock, xine_post_api_t::set_parameters, xine_list_push_back(), and XINE_POST_DATA_PARAMETERS.

Referenced by mosaico_init_plugin().

## ◆ mosaico_set_parameters()

static int mosaico_set_parameters | ( | xine_post_t * | this_gen,
|  | const void * | param_gen
| ) |  |
| static

References mosaico_parameters_s::h, mosaico_parameters_s::pip_num, mosaico_parameters_s::w, mosaico_parameters_s::x, and mosaico_parameters_s::y.

Referenced by mosaico_open_plugin().

## ◆ PARAM_ITEM()

PARAM_ITEM | ( | PARAM_ITEM( | POST_PARAM_TYPE_INT,
|  | pip_num | ,
|  | PARAM_ITEM( | NULL,
|  | 1 | ,
|  | PARAM_ITEM( | INT_MAX,
|  | 1 | ,
|  | "which picture slots settings are being edited" |
| ) |  |

## Variable Documentation

## ◆ EXPORTED

const plugin_info_t xine_plugin_info [] EXPORTED

Initial value:
= {
{ PLUGIN_POST, 10, "mosaico", XINE_VERSION_CODE, &mosaico_special_info, &mosaico_init_plugin },
{ PLUGIN_NONE, 0, NULL, 0, NULL, NULL }
}
mosaico_special_info
static const post_info_t mosaico_special_info
Definition: mosaico.c:466
mosaico_init_plugin
static void * mosaico_init_plugin(xine_t *xine, const void *data)
Definition: mosaico.c:450
XINE_VERSION_CODE
#define XINE_VERSION_CODE
Definition: xine_internal.h:57
NULL
NULL
Definition: xine_plugin.c:78
PLUGIN_NONE
#define PLUGIN_NONE
Definition: xine_plugin.h:29
PLUGIN_POST
#define PLUGIN_POST
Definition: xine_plugin.h:37

## ◆ mosaico_special_info

const post_info_t mosaico_special_info
| static

Initial value:
= {
.type = XINE_POST_TYPE_VIDEO_COMPOSE,
}
XINE_POST_TYPE_VIDEO_COMPOSE
#define XINE_POST_TYPE_VIDEO_COMPOSE
Definition: xine.h:823